//resilience file
#include "res.h"


void get_str_res(struct res_dimension * res_d, t_Tracedef_Argument *a) {
/* gets a res_dimension from a string argument */
/*strings can be one of 4 types...*/
	/*called from main.cpp
		case tr_PCHAR:
	case tr_PFMTCHAR:
	case tr_PWCHAR:
	case tr_PFMTWCHAR:
		fprintf(fd," [%08X] = %s",a->data.address,a->comment.c_str());
		get_str_res(res,a);
		break;
		*/
	res_dimension *res=new res_dimension;
	res_init(res);

	const char *comment=a->comment.c_str(); //init
	printf("Length=%d\n",a->comment.size());
	int length=0;
	
	if (a->Type==tr_PCHAR || a->Type==tr_PFMTCHAR) {
		
		strhash myhash;
		strhash_init(&myhash);
		const char *p=comment;
		printf("strhashing *%s*\n",p);
		while (*p!=0) {
			strhash_add(&myhash,*p);
			p++;
			length++;
		}
		double value=(strhash_get(&myhash)*100)/length;
		//printf("res_add length: %d value %.0lf\n",length,value);
		//who am I to argue with strlen?
		//printf("strlen=%d\n",strlen(comment));
		res_add(res,length);
		//here we have a tiny equation to measure "weirdness per character"
		res_add(res,value);
		
	} else {
	// wide character. Hopefully not screwed up. 

		//current strategy - treat as 2 strings :>
		const char *sp,*sp2;
		
		strhash myhash;
		strhash_init(&myhash);
		strhash myhash2;
		strhash_init(&myhash2);
		sp=comment;
		sp2=comment+1;
		while (*sp!=0 && *sp2!=0) {
			strhash_add(&myhash,*sp);		
			strhash_add(&myhash2,*sp2);
			sp++;
			sp2++;
			length++;
		}
		res_add(res,length);
		res_add(res,strhash_get(&myhash));
		res_add(res,strhash_get(&myhash2));
		

	}
	res_add_res(res_d,res);
	

//	return res;
}


void strhash_init(struct strhash *myhash) {
  myhash->path=0;
  myhash->high=0;
  myhash->percent=0;
  myhash->ff=0;

}

//this is an important function because it defines how we create hashes
//and what elements we store from a string
//somewhat broken on widechar still because we don't take it into account...
//of course, it still might be smarter to just store all these as their
//own double values...but whatever.
void strhash_add(struct strhash *myhash, unsigned char newchar) {
	if (newchar == '\\' || newchar == '/' || newchar =='.') {
		myhash->path+=1;	
	}

	//high bit check
	if (newchar & 0x80 ) {
		myhash->high+=1;
	}

	if (newchar == '%' ) {
		myhash->percent+=1;
	}

	if (newchar == 0xff) {
		myhash->ff+=1;
	}
}


//take the properties we stored off and return a single double for them
double strhash_get(struct strhash *myhash) {
	double ret=0;
	int ret2=0;
	//printf("strhash_get %d %d %d %d\n",myhash->ff,myhash->high,myhash->path,myhash->percent);
	
	ret=myhash->ff*10+myhash->high*8+myhash->path*3+myhash->percent;
	
	ret2=myhash->path;
	//printf("strhash_get Returning %lf or %d\n",ret,myhash->path);
	return ret;

}

void res_add(struct res_dimension * res, double newval) {
	res->length+=1;
	res->value=(double *)realloc(res->value,sizeof(double)*res->length);
	res->value[res->length-1]=newval;
}

void res_init(struct res_dimension *res) {
	res->value=(double *)malloc(sizeof(double)*2);
	memset(res->value,0,sizeof(double)*2);
	res->length=0;

}

void res_free(struct res_dimension *res) {
	free(res->value);
	res->length=0;
}

void res_print(FILE * fout,struct res_dimension *res) {
  int i=0;
  
  while (i<res->length) {
	fprintf(fout,"%.0lf,",res->value[i]);
	i++;
	
  }
  fprintf(fout,"\n");
  
}

void res_add_res(struct res_dimension *res_d,struct res_dimension *res) {
    int i=0;
	//printf("res_add_res %d to %d\n",res->length,res_d->length);
	while (i<res->length) {	 
	 //printf("Value copied: %lf\n",res->value[i]);
	 res_add(res_d,res->value[i]);
	 i++;
	}
}
